Bug 1005780 - Liberation Sans Mono Enhancement Request: Modification needed for "l" Character
Summary: Liberation Sans Mono Enhancement Request: Modification needed for "l" Character
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: liberation-fonts
Version: 19
Hardware: All
OS: All
unspecified
low
Target Milestone: ---
Assignee: Pravin Satpute
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-09-09 11:58 UTC by Reed Kerr
Modified: 2015-02-18 11:26 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-02-18 11:26:34 UTC


Attachments (Terms of Use)
screenshot of comparison between dejavu mono and liberation mono l character (25.50 KB, image/png)
2013-09-11 08:50 UTC, Pravin Satpute
no flags Details
working image of "l" shape (25.98 KB, image/png)
2013-12-03 09:51 UTC, Pravin Satpute
no flags Details
Comparison of "l" in text (30.90 KB, image/png)
2013-12-03 13:50 UTC, Reed Kerr
no flags Details
Showing new character at 11, 12, and 13 (607 bytes, image/png)
2014-05-13 13:10 UTC, Reed Kerr
no flags Details
Showing new character at various sizes (2.58 KB, image/png)
2014-05-13 13:28 UTC, Reed Kerr
no flags Details

Description Reed Kerr 2013-09-09 11:58:13 UTC
Description of problem: 
Lowercase "l" character very closely resembles the "1" character from many other typefaces, especially at smaller point sizes, and even more so in the italic style.

Version-Release number of selected component (if applicable): 
2.00.1

How reproducible:
Type an italic "l" at 8 point size. Print alongside "1" also at 8 point size from some other monospaced fonts, such as DejaVu Sans Mono and notice the similarity.

Additional info:
I have found Liberation Mono to be the best Free typeface for my coding purposes. I particularly love how readable yet compact it is at small sizes. I've had difficultly though with the "l" character. I find that this character seems to me to be indistinguishable from the "1" character from many other typefaces. The problem is even more apparent when the font is used in the italic style. To my perception, an "l" formed more similar to that of the DejaVu Sans Mono, Source Code Pro, or Ubuntu Mono would fit better with the overall design approach of the typeface by being clearly readable at all sizes--it could no longer be confused with any other character. This would include a leftward serif at the top of the letter, and a rightward curvature at the bottom of the character. To my eye, DejaVu Sans Mono's "l" would be the best model.

Comment 1 Pravin Satpute 2013-09-11 08:50:45 UTC
Created attachment 796295 [details]
screenshot of comparison between dejavu mono and liberation mono l character

Thanks for appreciation for Liberation. After looking at the attached screenshot i am agree with you for confusion at lower size between 1 and l. 

Looks like Dejavu has taken extra care while designing l shape. I will try for that in next version.

Comment 2 Reed Kerr 2013-11-15 13:31:34 UTC
(In reply to Pravin Satpute from comment #1)
> Created attachment 796295 [details]
> screenshot of comparison between dejavu mono and liberation mono l character
> 
> Thanks for appreciation for Liberation. After looking at the attached
> screenshot i am agree with you for confusion at lower size between 1 and l. 
> 
> Looks like Dejavu has taken extra care while designing l shape. I will try
> for that in next version.

Thank you so much! I look forward to seeing it.

Is there a schedule for the next release?

Comment 3 Pravin Satpute 2013-11-18 13:16:00 UTC
I will do this it by this month end.

Comment 4 Pravin Satpute 2013-12-03 08:51:01 UTC
We can definitely fix this but i am more concerned regarding if we update shape we will lose the bytecode hinting instruction for this shape.

Though i can instruct fontforge for autohinting this but still it does not give 100% accurate behaviour.

So may be we can try this out but if some bugs came up, we can simply restore original shape or try to fix hinting instructions.

Comment 5 Pravin Satpute 2013-12-03 09:51:11 UTC
Created attachment 831954 [details]
working image of "l" shape

Does this looks good? Minimal approach to resolve confusion :)

Comment 6 Reed Kerr 2013-12-03 13:49:02 UTC
It certainly is less confusing and I would consider it an improvement, though a rounded curvature at the bottom would be still better in my mind. Rounding the bottom would make it more recognizable as a lowercase "l". Your working image could possibly be confused as a capital "L".

I've attached an image of how things currently look in DejaVu Sans Mono, Source Code Pro, Ubuntu Mono, and Liberation Mono. An "l" shaped like one of the first three would be ideal to my perception, though admittedly I don't fully understand all of the technical implications of adopting such a design.

Thanks!

Comment 7 Reed Kerr 2013-12-03 13:50:38 UTC
Created attachment 832085 [details]
Comparison of "l" in text

Comment 8 Pravin Satpute 2013-12-04 05:52:05 UTC
Yes agree, round shape at bottom required to avoid confusion with capital "L"

Comment 9 Reed Kerr 2014-01-21 14:28:00 UTC
Is a fix for this still being considered for inclusion in the next release, and is there any timeframe in mind for this?

Comment 10 Pravin Satpute 2014-01-22 05:33:36 UTC
Problem here is, if we modify this shape we will lost the hinting instruction for this shape. 

Definitely same time we can do auto hinting but it will not give as sharp outline as given by present hinting instruction.

Will do one thing, i will modify and provide test file, please test those and update me on same.

will do it this week.

Comment 11 Reed Kerr 2014-02-11 20:05:01 UTC
I would be love to see an updated file when it's available and would be happy to give feedback.

Thank you!

Comment 12 LiberationLove 2014-03-07 06:47:10 UTC
Can I download update somewhere? Bug with 1 VS l is blocking for me.

Comment 13 Pravin Satpute 2014-03-07 07:06:16 UTC
Hi, 
  Nice username :) 
  Just give me one week. i am working on fixing #1072095, hoping to fix this bug as well with it.

Comment 14 Reed Kerr 2014-04-15 17:25:24 UTC
Is there a status update on this?

Comment 15 Pravin Satpute 2014-04-16 05:14:10 UTC
Not yet..looking forward to complete it this month.

Comment 16 Spiderhunter 2014-05-09 10:51:11 UTC
No updates? Any problems?

Comment 17 Pravin Satpute 2014-05-09 10:55:55 UTC
I am working on liberation fonts from last 2 weeks, soon will touch this issue.

In between Liberation fonts version 2 also available on github now https://github.com/pravins/liberation-fonts

Comment 18 Pravin Satpute 2014-05-13 10:40:06 UTC
first of all apologies for taking so much time for this.

I have updated 'l' shape in mono all relevant files are available @ 

http://pravins.fedorapeople.org/liberation-mono/

Please test .ttf and update me whether any issue or more required.

Comment 19 Reed Kerr 2014-05-13 13:08:26 UTC
I love the new shape! Thank you so much.

It does seem to render oddly at the 12 point size on my system. I'm attaching a screenshot of how it's rendering at 11, 12, and 13 sizes. the leftward serif at the top seems unproportionally wide at 12, though the other sizes seem fine.

I took the screenshot in MS Word, but I've confirmed that it does the same in other applications on my system as well. Is that a problem on my system, or something in the font file?

Comment 20 Reed Kerr 2014-05-13 13:10:22 UTC
Created attachment 895130 [details]
Showing new character at 11, 12, and 13

Notice the width of the leftward serif at the top of the character at 12. It does not appear proportional to the 11 and 13 sizes. This screenshot was taken in MS Word 2013 on Windows 7.

Comment 21 Reed Kerr 2014-05-13 13:28:13 UTC
Created attachment 895135 [details]
Showing new character at various sizes

This screenshot was taken on the same Windows 7 system in LibreOffice Writer 4.2.2.1. It shows the 'l' character at all the common sizes, and highlights the inconsistencies in the leftward serif at the top of the character.

12, 14 and 15 seem unusually wide, while 13, 16 and 18 seem significantly more narrow. As I noted if my earlier comment though, the 12 size seems the most problematic to my perception.

Comment 22 Pravin Satpute 2014-10-14 05:25:14 UTC
I was waiting to fix this issue before next upstream release. Just update to shape will not work, we need to add correct hinting instructions as well to fix this. 

I will do next release with other fix and keep this pending for next one.

Comment 23 Fedora End Of Life 2015-01-09 22:17:46 UTC
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 24 Fedora End Of Life 2015-02-18 11:26:34 UTC
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.